<?php
/*
Plugin Name: IP посетителей в метрике
Plugin URI: https://itryzen.com/catalog/save-ip-yandex-metrika/
Description: Сохраняет IP посетителей сайта в Яндекс.Метрике и отображает их в вебвизоре.
Author: Monolit Studio
Author URI: https://t.me/IT_DD
Version: 1.1
*/

// Добавляем страницу с настройками в сайдбаре
add_action('admin_menu', 'ip_metric_tracker_menu');

function ip_metric_tracker_menu() {
    add_options_page(
        'Настройки IP Метрики',
        'IP Метрика',
        'manage_options',
        'ip-metric-settings',
        'ip_metric_tracker_settings_page'
    );
}

// Функция отображения страницы настроек
function ip_metric_tracker_settings_page() {
    ?>
    <div class="wrap">
        <h2>Настройки IP Метрики</h2>
        <form method="post" action="options.php">
            <?php
            settings_fields('ip-metric-settings');
            do_settings_sections('ip-metric-settings');
            ?>
            <h3>Введите код метркии</h3>
            <label for="" style="display:flex;flex-wrap:wrap;gap:10px; align-items:center; margin: 10px 0 15px 0">
            <span>Код <a href="https://metrika.yandex.ru/list" target="_blank">яндекс метрики</a>:</span>
              <input type="text" name="ip_metric_code" value="<?php echo esc_attr(get_option('ip_metric_code')); ?>">
            <?php submit_button(); ?>
            </label>
        </form>
        <div class="demo">
            <input class="hide" id="hd-1" type="checkbox">
            <label for="hd-1">Где взять код? Где смотреть ip? Ответы на вопросы.</label>
            <div>
            <p>
            <b>Как получить код яндекс метрики?</b>
            </p>
            <p>
            Откройте сайт <a href="https://metrika.yandex.ru/list" target="_blank">метрики</a> и скопируйте код метрики *<a href="https://i.imgur.com/7rMJEXy.png" target="_blank">фотография</a>*.
            </p><br>
            <p>
            <b>Где смотреть ip посетителей?</b>
            </p>
            <p>
            Откройте вебвизор, в столбике "Параметры визита" отобразятся ип посетителей *<a href="https://i.imgur.com/1YFLVtg.png" target="_blank">фотография</a>*
            </p><br>
            <p>
            <b>Нет ип в метрике?</b>
            </p>
            <p>
            Убедитесь что у вас включен вебвизор *<a href="https://i.imgur.com/vIyk09G.png" target="_blank">фотография</a>*
            </p><br>
            <p>
            <b>Нет ип в метрике?</b>
            </p>
            <p>
            1. Убедитесь что у вас включен вебвизор *<a href="https://i.imgur.com/vIyk09G.png" target="_blank">фотография</a>*<br>
            2. Включите столбик "параметры визита" *<a href="https://i.imgur.com/QrROTe9.png" target="_blank">фотография</a>*
            </p>
            <p>
            Дополнительные ответы на вопросы можно найти на странице плагина *<a href=" https://itryzen.com/catalog/save-ip-yandex-metrika/" target="_blank">itryzen.com</a>*
            </p>
            </div>
        </div>
        <style>
        /* скрываем чекбоксы и блоки с содержанием */
        .hide{
            display: none!important;
        }label .submit{
            margin: 0;
            padding: 0;
        }
        .hide,
        .hide + label ~ div {
            display: none;
        }
        /* вид текста label */
        .hide + label {
            margin: 0;
            padding: 0;
            color: green;
            cursor: pointer;
            display: inline-block;
        }
        /* вид текста label при активном переключателе */
        .hide:checked + label {
            color: red;
            border-bottom: 0;
        }
        /* когда чекбокс активен показываем блоки с содержанием  */
        .hide:checked + label + div {
            display: block; 
            background: #efefef;
            -moz-box-shadow: inset 3px 3px 10px #7d8e8f;
            -webkit-box-shadow: inset 3px 3px 10px #7d8e8f;
            box-shadow: inset 3px 3px 10px #7d8e8f;
            margin-left: 20px;
            padding: 10px;
            /* чуточку анимации при появлении */
            -webkit-animation:fade ease-in 0.2s; 
            -moz-animation:fade ease-in 0.2s;
            animation:fade ease-in 0.2s; 
        }
        /* анимация при появлении скрытых блоков */
        @-moz-keyframes fade {
            from { opacity: 0; }
        to { opacity: 1 }
        }
        @-webkit-keyframes fade {
            from { opacity: 0; }
        to { opacity: 1 }
        }
        @keyframes fade {
            from { opacity: 0; }
        to { opacity: 1 }   
        }
        .hide + label:before {
            background-color: #2271B1;
            color: #fff;
            content: "\002B";
            display: block;
            float: left;
            font-size: 14px; 
            font-weight: bold;
            height: 16px;
            line-height: 16px;
            margin: 3px 5px;
            text-align: center;
            width: 16px;
            -webkit-border-radius: 50%;
            -moz-border-radius: 50%;
            border-radius: 50%;
        }
        .hide:checked + label:before {
            content: "\2212";
        }
        </style>
    </div>
    <?php
}

// Регистрация настроек
add_action('admin_init', 'ip_metric_tracker_settings');

function ip_metric_tracker_settings() {
    register_setting('ip-metric-settings', 'ip_metric_code');
}

// Добавление кода метрики в футер сайта
add_action('wp_footer', 'ip_metric_tracker_add_code');

function ip_metric_tracker_add_code() {
    $ip_metric_code = get_option('ip_metric_code');
    if ($ip_metric_code) {
        echo '<script>';
        echo 'ym(' . esc_js($ip_metric_code) . ', "params", { ip_address: "' . esc_js(ip_metric_tracker_get_client_ip()) . '" });';
        echo '</script>';
    }
}

// Получение IP адреса пользователя
function ip_metric_tracker_get_client_ip() {
    if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])) {
        return $_SERVER['HTTP_CF_CONNECTING_IP'];
    } else {
        return $_SERVER['REMOTE_ADDR'];
    }
}
